<?php

class Config extends Env {
    const SDCARD_CONF_PATH                  = "/mnt/sdcard/ksweb/conf";

    const PHP_CONF_PATH                     = "/data/data/ru.kslabs.ksweb/components/php/conf/php.ini";
    const MYSQL_CONF_PATH                   = "/data/data/ru.kslabs.ksweb/components/mysql/conf/my.ini";

    const SERVER_LIGHTTPD_CONF_PATH         = "/data/data/ru.kslabs.ksweb/components/lighttpd/conf/lighttpd.conf";
    const SERVER_LIGHTTPD_CONF_DIR          = "/data/data/ru.kslabs.ksweb/components/lighttpd/conf";

    const SERVER_NGINX_CONF_PATH            = "/data/data/ru.kslabs.ksweb/components/nginx/conf/nginx.conf";
    const SERVER_NGINX_CONF_DIR             = "/data/data/ru.kslabs.ksweb/components/nginx/conf";

    const SERVER_APACHE_CONF_PATH           = "/data/data/ru.kslabs.ksweb/components/httpd/conf/httpd.conf";
    const SERVER_APACHE_CONF_DIR            = "/data/data/ru.kslabs.ksweb/components/httpd/conf";

    const PHP_CONF_SDCARD_PATH              = "/mnt/sdcard/ksweb/conf/php/php.ini";
    const PHP_CONF_SDCARD_DIR               = "/mnt/sdcard/ksweb/conf/php";
    const MYSQL_CONF_SDCARD_PATH            = "/mnt/sdcard/ksweb/conf/mysql/my.ini";
    const MYSQL_CONF_SDCARD_DIR             = "/mnt/sdcard/ksweb/conf/mysql";

    const SERVER_LIGHTTPD_CONF_SDCARD_PATH  = "/mnt/sdcard/ksweb/conf/lighttpd/lighttpd.conf";
    const SERVER_LIGHTTPD_CONF_SDCARD_DIR   = "/mnt/sdcard/ksweb/conf/lighttpd";

    const SERVER_NGINX_CONF_SDCARD_PATH     = "/mnt/sdcard/ksweb/conf/nginx/nginx.conf";
    const SERVER_NGINX_CONF_SDCARD_DIR      = "/mnt/sdcard/ksweb/conf/nginx";

    const SERVER_APACHE_CONF_SDCARD_PATH    = "/mnt/sdcard/ksweb/conf/apache/httpd.conf";
    const SERVER_APACHE_CONF_SDCARD_DIR     = "/mnt/sdcard/ksweb/conf/apache";

    const MYSQL_LANGUAGE_FILE_PATH          = "/data/data/ru.kslabs.ksweb/components/mysql/sbin/share/mysql/english";

    const LIGHTTPD_BIN_PATH                 = "/data/data/ru.kslabs.ksweb/components/lighttpd/sbin/lighttpd";
    const LIGHTTPD_LIB_PATH                 = "/data/data/ru.kslabs.ksweb/components/lighttpd/lib";

    const NGINX_BIN_PATH                    = "/data/data/ru.kslabs.ksweb/components/nginx/sbin/nginx";
    const NGINX_LIB_PATH                    = "/data/data/ru.kslabs.ksweb/components/nginx/lib";

    const APACHE_BIN_PATH                   = "/data/data/ru.kslabs.ksweb/components/httpd/bin/apache";
    const APACHE_LIB_PATH                   = "/data/data/ru.kslabs.ksweb/components/httpd/lib";

    const MYSQLD_BIN_PATH                   = "/data/data/ru.kslabs.ksweb/components/mysql/sbin/mysqld";

    const TMP_FILE_CONFIG                   = "/data/data/ru.kslabs.ksweb/tmp/tempConfig.ini";
    
    private $currentConfig;
    private $type;
    private $server;

    public function __construct($configType, $engine, $hostname = "") {
        parent::__construct($engine);
        $settings = (new KSWEBSettings())->get();
        $move_inis = $settings["move_inis"];

        
        if ($configType == ConfigType::LIGHTTPD_HOST) {
            $this->currentConfig = ($move_inis == "true") ? Config::SERVER_LIGHTTPD_CONF_SDCARD_DIR."/".$hostname : Config::SERVER_LIGHTTPD_CONF_DIR."/".$hostname;
            $this->server = Server::LIGHTTPD;
        }
        
        if ($configType == ConfigType::NGINX_HOST) {
            $this->currentConfig = ($move_inis == "true") ? Config::SERVER_NGINX_CONF_SDCARD_DIR."/".$hostname : Config::SERVER_NGINX_CONF_DIR."/".$hostname;
            $this->server = Server::NGINX;
        }
        
        if ($configType == ConfigType::APACHE_HOST) {
            $this->currentConfig = ($move_inis == "true") ? Config::SERVER_APACHE_CONF_SDCARD_DIR."/".$hostname : Config::SERVER_APACHE_CONF_DIR."/".$hostname;
            $this->server = Server::APACHE;
        }
        
        if ($configType == ConfigType::SERVER_LIGHTTPD) {
            $this->currentConfig = ($move_inis == "true") ? Config::SERVER_LIGHTTPD_CONF_SDCARD_PATH : Config::SERVER_LIGHTTPD_CONF_PATH;
            $this->server = Server::LIGHTTPD;
        }

        if ($configType == ConfigType::SERVER_NGINX) {
            $this->currentConfig = ($move_inis == "true") ? Config::SERVER_NGINX_CONF_SDCARD_PATH : Config::SERVER_NGINX_CONF_PATH;
            $this->server = Server::NGINX;
        }

        if ($configType == ConfigType::SERVER_APACHE) {
            $this->currentConfig = ($move_inis == "true") ? Config::SERVER_APACHE_CONF_SDCARD_PATH : Config::SERVER_APACHE_CONF_PATH;
            $this->server = Server::APACHE;
        }

        if ($configType == ConfigType::PHP) {
            $this->currentConfig = ($move_inis == "true") ? Config::PHP_CONF_SDCARD_PATH : Config::PHP_CONF_PATH;
            $this->server = Server::PHP;
        }

        if ($configType == ConfigType::MYSQL) {
            $this->currentConfig = ($move_inis == "true") ? Config::MYSQL_CONF_SDCARD_PATH : Config::MYSQL_CONF_PATH;
            $this->server = Server::MYSQL;
        }

        $this->type = $configType;
    }

    public function getConfigFullPath() {
        return $this->currentConfig;
    }

    public function getConfigFileName() {
        echo basename($this->currentConfig);
    }
    
    private function saveTMPConfig($content) {
        unlink(Config::TMP_FILE_CONFIG);
        $fp = fopen(Config::TMP_FILE_CONFIG, "a");
        fwrite($fp, $content);
        fclose($fp);
        shell_exec("chmod 644 ".Config::TMP_FILE_CONFIG);
    }

    public function testConfig($content) {
        $this->saveTMPConfig($content);
        
        $message = "";
        $testOk = false;
        
        if ($this->type == ConfigType::SERVER_LIGHTTPD || $this->type == ConfigType::LIGHTTPD_HOST) {
            $output = str_replace("\n", "<br>", shell_exec("LD_LIBRARY_PATH=" . Config::LIGHTTPD_LIB_PATH . " " . Config::LIGHTTPD_BIN_PATH . " -t -f ".Config::TMP_FILE_CONFIG." 2>&1"));
            $message = "============<br>Testing config...<br>" . $output . "============<br>";
            if (strpos($output, "yntax OK")) $testOk = true;
        }

        if ($this->type == ConfigType::PHP || $this->type == ConfigType::NGINX_HOST) {
            $testOk = true;
        }

        if ($this->type == ConfigType::MYSQL) {
            $output = str_replace("\n", "<br>", shell_exec(Config::MYSQLD_BIN_PATH . " --defaults-file=".Config::TMP_FILE_CONFIG." --lc-messages-dir=".Config::MYSQL_LANGUAGE_FILE_PATH." --help --verbose 2>&1 1>/dev/null")); //1>/dev/null
            $message = "============<br>Testing config...<br>" . $output . "============<br>";
            if (!strpos($output, "[ERROR]")) {
                $testOk = true;
            }
        }
        if ($this->type == ConfigType::SERVER_NGINX) {
            $output = str_replace("\n", "<br>", shell_exec("LD_LIBRARY_PATH=" . Config::NGINX_LIB_PATH . " " . Config::NGINX_BIN_PATH . " -t -c ".Config::TMP_FILE_CONFIG." 2>&1"));
            $message = "============<br>Testing config...<br>" . $output . "============<br>";
            if (strpos($output, "syntax is ok")) $testOk = true;
        }


        if ($this->type == ConfigType::SERVER_APACHE || $this->type == ConfigType::APACHE_HOST) {
            $output = str_replace("\n", "<br>", shell_exec("LD_LIBRARY_PATH=" . Config::APACHE_LIB_PATH . " " . Config::APACHE_BIN_PATH . " -t -f " . Config::TMP_FILE_CONFIG . " 2>&1 1>/dev/null"));
            $message = "============<br>Testing config...<br>" . $output . "============<br>";
            if (strpos($output, "yntax OK")) {
                $testOk = true;
            }
        }

        if ($this->type == -1) {
            $testOk = true;
        }
        
        $result["testOk"] = $testOk;
        $result["message"] = $message;
        
        return $result;
    }

    public static function defineType($configFile) {
        if ($configFile == Config::PHP_CONF_PATH || $configFile == Config::PHP_CONF_SDCARD_PATH) {
            return ConfigType::PHP;
        }
        if ($configFile == Config::MYSQL_CONF_PATH || $configFile == Config::MYSQL_CONF_SDCARD_PATH) {
            return ConfigType::MYSQL;
        }
        if ($configFile == Config::SERVER_LIGHTTPD_CONF_PATH || $configFile == Config::SERVER_LIGHTTPD_CONF_SDCARD_PATH) {
            return ConfigType::SERVER_LIGHTTPD;
        }
        if ($configFile == Config::SERVER_NGINX_CONF_PATH || $configFile == Config::SERVER_NGINX_CONF_SDCARD_PATH) {
            return ConfigType::SERVER_NGINX;
        }
        if ($configFile == Config::SERVER_APACHE_CONF_PATH || $configFile == Config::SERVER_APACHE_CONF_SDCARD_PATH) {
            return ConfigType::SERVER_APACHE;
        }
        return -1;
    }

    public function getConfigFileContent() {
        return file_get_contents($this->currentConfig);
    }

    public function saveConfig() {
        @unlink($this->getConfigFullPath());
        $result = copy(Config::TMP_FILE_CONFIG, $this->getConfigFullPath());
        return $result;
    }

    private static function createConfDirOnSDCARD() {
        @mkdir(Config::SDCARD_CONF_PATH);
        @mkdir(Config::SERVER_LIGHTTPD_CONF_SDCARD_DIR);
        @mkdir(Config::SERVER_NGINX_CONF_SDCARD_DIR);
        @mkdir(Config::SERVER_APACHE_CONF_SDCARD_DIR);
        @mkdir(Config::PHP_CONF_SDCARD_DIR);
        @mkdir(Config::MYSQL_CONF_SDCARD_DIR);
    }

    public static function copyAllConfigFiles() {

        Config::createConfDirOnSDCARD();

		$result = true;

		//PHP
        $thing['source'] = Config::PHP_CONF_PATH;
        $thing['dest'] = Config::PHP_CONF_SDCARD_PATH;
        $confFileArray[0] = $thing;

        //MYSQL
        $thing['source'] = Config::MYSQL_CONF_PATH;
        $thing['dest'] = Config::MYSQL_CONF_SDCARD_PATH;
        $confFileArray[1] = $thing;

        //LIGHTTPD
        $thing['source'] = Config::SERVER_LIGHTTPD_CONF_PATH;
        $thing['dest'] = Config::SERVER_LIGHTTPD_CONF_SDCARD_PATH;
        $confFileArray[2] = $thing;


        //NGINX
        $thing['source'] = Config::SERVER_NGINX_CONF_PATH;
        $thing['dest'] = Config::SERVER_NGINX_CONF_SDCARD_PATH;
        $confFileArray[3] = $thing;


        //APACHE
        $thing['source'] = Config::SERVER_APACHE_CONF_PATH;
        $thing['dest'] = Config::SERVER_APACHE_CONF_SDCARD_PATH;
        $confFileArray[4] = $thing;

        for ($i = 0; $i < count($confFileArray); $i++) {
            if (!copy($confFileArray[$i]['source'], $confFileArray[$i]['dest'])) {
                $result = false;
            }
        }

		return $result;
    }

    public static function copyAllHosts() {
        Config::deleteAllHostsFromSDLighttpd();
		
        $result = "";
		
        foreach (glob(Config::SERVER_LIGHTTPD_CONF_DIR."/*_host.conf") as $file) {

            if (copy($file, Config::SERVER_LIGHTTPD_CONF_SDCARD_DIR ."/". basename($file))) {
                $result .= "Copied file: " . $file . " -> " . Config::SERVER_LIGHTTPD_CONF_SDCARD_DIR ."/". basename($file) . "<br>";
            } else {
                $result .= "Error copying file: " . $file . " -> " . Config::SERVER_LIGHTTPD_CONF_SDCARD_DIR ."/". basename($file) . "<br>";
            }

        }

        Config::deleteAllHostsFromSDNginx();
        foreach (glob(Config::SERVER_NGINX_CONF_DIR."/*_host.conf") as $file) {

            if (copy($file, Config::SERVER_NGINX_CONF_SDCARD_DIR ."/". basename($file))) {
                $result .= "Copied file: " . $file . " -> " . Config::SERVER_NGINX_CONF_SDCARD_DIR  ."/". basename($file) . "<br>";
            } else {
                $result .= "Error copying file: " . $file . " -> " . Config::SERVER_NGINX_CONF_SDCARD_DIR  ."/". basename($file) . "<br>";
            }

        }

        Config::deleteAllHostsFromSDApache();
        foreach (glob(Config::SERVER_APACHE_CONF_DIR."/*_host.conf") as $file) {

            if (copy($file, Config::SERVER_APACHE_CONF_SDCARD_DIR ."/". basename($file))) {
                $result .= "Copied file: " . $file . " -> " . Config::SERVER_APACHE_CONF_SDCARD_DIR  ."/". basename($file) . "<br>";
            } else {
                $result .= "Error copying file: " . $file . " -> " . Config::SERVER_APACHE_CONF_SDCARD_DIR  ."/". basename($file) . "<br>";
            }

        }

		return $result;
	}

    public static function deleteAllHostsFromSDLighttpd() {
        foreach (glob(Config::SERVER_LIGHTTPD_CONF_SDCARD_DIR."/*_host.conf") as $file) {
            unlink($file);
        }
    }

    public static function deleteAllHostsFromSDNginx() {
        foreach (glob(Config::SERVER_NGINX_CONF_SDCARD_DIR."/*_host.conf") as $file) {
            unlink($file);
        }
    }

    public static function deleteAllHostsFromSDApache() {
        foreach (glob(Config::SERVER_APACHE_CONF_SDCARD_DIR."/*_host.conf") as $file) {
            unlink($file);
        }
    }

    public static function getConfigType($serverType) {
        if ($serverType == Server::LIGHTTPD) return ConfigType::SERVER_LIGHTTPD;
        if ($serverType == Server::NGINX) return ConfigType::SERVER_NGINX;
        if ($serverType == Server::APACHE) return ConfigType::SERVER_APACHE;
        return ConfigType::SERVER_LIGHTTPD;
    }
    
    function showServerConfigHref($server) {
        echo "<h5>".Server::getTextName($server)." config</h5><p>";
        if ($server == Server::LIGHTTPD) echo "<p><a class='blue-text text-darken-4' href = '".$this->engine->getUrl()->getCurrentAddress()."&server={$server}'>Config file: ".$this->getConfigFullPath()."</a></p>";
        if ($server == Server::NGINX) echo "<p><a class='blue-text text-darken-4' href = '".$this->engine->getUrl()->getCurrentAddress()."&server={$server}'>Config file: ".$this->getConfigFullPath()."</a></p>";
        if ($server == Server::APACHE) echo "<p><a class='blue-text text-darken-4' href = '".$this->engine->getUrl()->getCurrentAddress()."&server={$server}'>Config file: ".$this->getConfigFullPath()."</a></p>";
        echo "</p>";
    }
    
    function getHostListTxt() {
        $f = scandir(dirname($this->getConfigFullPath()));
        
        $newType = $this->type;
        switch ($this->type) {
            case ConfigType::SERVER_APACHE:
                $newType = ConfigType::APACHE_HOST;
                break;
            case ConfigType::SERVER_LIGHTTPD:
                $newType = ConfigType::LIGHTTPD_HOST;
                break;
            case ConfigType::SERVER_NGINX:
                $newType = ConfigType::NGINX_HOST;
                break;
        }
        
        $output = "";
        if ($f != false) {
            $title = "<h5>".Server::getTextName($this->server)." host files list</h5><p>";
            foreach($f as $file) {
                if (preg_match('/\_(host)/', $file)) {
                    $output .= "<p><a class='blue-text text-darken-4' href = '".$this->engine->getUrl()->getCurrentAddress()."&configType=".$newType."&hostname=$file'>Open host: ".$file."</a></p>";
                }
            }
            if ($output != "") { $output = $title.$output; }
        }
        return $output;
    }
}