<!DOCTYPE html>
<html lang="en">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="description" content="">
        <meta name="author" content="">
        <link rel="shortcut icon" href="web/favicons/favicon.ico">

        <title><?= $title; ?></title>

        <?= $this->generateCSSStylesHtml(); ?>
        <?= $this->generateJSScriptsHtml(); ?>
    
    </head>

    <body class="grey lighten-3">

        <nav class="nav-extended blue">
            <div class="nav-wrapper">
                <a href="./" class="left brand-logo"><span class="ksweb-title">KSWEB WebFace&nbsp;3.0</span></a>
                <ul class="right">
                    <li>
                        <a class="nocover" href="?action=phpinfo">
                            <svg style="width:35px;height:35px" viewBox="0 0 24 24">
                                <path fill="#fff" d="M12,18.08C5.37,18.08 0,15.36 0,12C0,8.64 5.37,5.92 12,5.92C18.63,5.92 24,8.64 24,12C24,15.36 18.63,18.08 12,18.08M6.81,10.13C7.35,10.13 7.72,10.23 7.9,10.44C8.08,10.64 8.12,11 8.03,11.47C7.93,12 7.74,12.34 7.45,12.56C7.17,12.78 6.74,12.89 6.16,12.89H5.29L5.82,10.13H6.81M3.31,15.68H4.75L5.09,13.93H6.32C6.86,13.93 7.3,13.87 7.65,13.76C8,13.64 8.32,13.45 8.61,13.18C8.85,12.96 9.04,12.72 9.19,12.45C9.34,12.19 9.45,11.89 9.5,11.57C9.66,10.79 9.55,10.18 9.17,9.75C8.78,9.31 8.18,9.1 7.35,9.1H4.59L3.31,15.68M10.56,7.35L9.28,13.93H10.7L11.44,10.16H12.58C12.94,10.16 13.18,10.22 13.29,10.34C13.4,10.46 13.42,10.68 13.36,11L12.79,13.93H14.24L14.83,10.86C14.96,10.24 14.86,9.79 14.56,9.5C14.26,9.23 13.71,9.1 12.91,9.1H11.64L12,7.35H10.56M18,10.13C18.55,10.13 18.91,10.23 19.09,10.44C19.27,10.64 19.31,11 19.22,11.47C19.12,12 18.93,12.34 18.65,12.56C18.36,12.78 17.93,12.89 17.35,12.89H16.5L17,10.13H18M14.5,15.68H15.94L16.28,13.93H17.5C18.05,13.93 18.5,13.87 18.85,13.76C19.2,13.64 19.5,13.45 19.8,13.18C20.04,12.96 20.24,12.72 20.38,12.45C20.53,12.19 20.64,11.89 20.7,11.57C20.85,10.79 20.74,10.18 20.36,9.75C20,9.31 19.37,9.1 18.54,9.1H15.79L14.5,15.68Z" />
                            </svg>
                        </a>
                    </li>
                </ul>
            </div>
            <div class="nav-content">
                <ul class="tabs tabs-transparent" style="display:flex;">
                    <li class="tab"><a <?= ($engine->getUrl()->isThisCurrentPage("/")) ? "class='active'" : ""; ?> href = '/' target="_self">Home</a></li>
                    <li class="tab"><a <?= ($engine->getUrl()->isThisCurrentPage("webserverconf")) ? "class='active'" : ""; ?> href = '?action=webserverconf' target="_self">SERVER CONFIG</a></li>
                    <li class="tab"><a <?= ($engine->getUrl()->isThisCurrentPage("mysqlconf")) ? "class='active'" : ""; ?> href = '?action=mysqlconf&configType=<?= ConfigType::MYSQL ?>' target="_self">MYSQL CONFIG</a></li>
                    <li class="tab"><a <?= ($engine->getUrl()->isThisCurrentPage("phpconf")) ? "class='active'" : ""; ?> href = '?action=phpconf&configType=<?= ConfigType::PHP ?>' target="_self">PHP CONFIG</a></li>
                    <li class="tab"><a <?= ($engine->getUrl()->isThisCurrentPage("kswebsettings")) ? "class='active'" : ""; ?> href = '?action=kswebsettings' target="_self">KSWEB SETTINGS</a></li>
                    <li class="tab"><a <?= ($engine->getUrl()->isThisCurrentPage("systemsettings")) ? "class='active'" : ""; ?> href = '?action=systemsettings' target="_self">SYSTEM SETTINGS</a></li>
                    <li class="tab"><a <?= ($engine->getUrl()->isThisCurrentPage("restartservers")) ? "class='active'" : ""; ?> href = '?action=restartservers' target="_self">RESTART SERVERS</a></li>
                </ul>
            </div>
        </nav>

        <?= $content; ?>


        <div class="center-block" style="padding: 15px">
            <span class="text-muted">&copy; <a href="https://kslabs.ru">KSLabs Team</a> 2012 - <?= date('Y') ?></span>
        </div>


  
    </body>

</html>